package frc.robot.subsystems;

import java.util.function.DoubleSupplier;

import com.revrobotics.spark.SparkMax;
import com.revrobotics.spark.SparkBase.PersistMode;
import com.revrobotics.spark.SparkBase.ResetMode;
import com.revrobotics.spark.SparkLowLevel.MotorType;

import edu.wpi.first.wpilibj2.command.Command;
import edu.wpi.first.wpilibj2.command.SubsystemBase;
import frc.robot.constants.IndexerConstants;

public class Indexer extends SubsystemBase {
    private SparkMax indexerMotor;

    public Indexer() {
        indexerMotor = new SparkMax(IndexerConstants.kIndexerMotorID, MotorType.kBrushless);

        indexerMotor.configure(
            IndexerConstants.motorConfig, 
            ResetMode.kResetSafeParameters, 
            PersistMode.kPersistParameters
        );
    }

    public Command runIndexer(DoubleSupplier speed) {
        return run(() -> {
            indexerMotor.set(speed.getAsDouble());
        });
    }
}
